Index: /pjproject/branches/projects/uwp/pjproject-vs14.sln
===================================================================
--- /pjproject/branches/projects/uwp/pjproject-vs14.sln	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjproject-vs14.sln	(revision 5254)
@@ -1650,4 +2229,17 @@
 		{207E7BD4-7B11-4A40-BA3A-CC627762A7B6} = {54F6163A-66C6-4F09-844D-CC61DE8EE376}
 		{E75EFD41-C7F5-44C8-8FF1-A310D920989D} = {54F6163A-66C6-4F09-844D-CC61DE8EE376}
+		{452C38CE-6463-4963-A113-658B6BD91D15} = {78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}
+		{DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F} = {78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}
+		{820034C1-645D-4340-8813-D980C1EF77DE} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
+		{C8D75245-FFCF-4932-A228-C9CC8BB60B03} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
+		{BBABEEA1-494C-4618-96E3-399873A5558B} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
+		{3085ACA0-00DA-45BF-9110-A3684B56EBBA} = {DE5C2BE2-873A-4B85-8EBE-8AEA4C80212F}
+		{D51DC5BE-5822-4B94-891C-E1B1B7892939} = {452C38CE-6463-4963-A113-658B6BD91D15}
+		{9C5609A2-32A2-483F-81EC-DAC2ED96BF6A} = {452C38CE-6463-4963-A113-658B6BD91D15}
+		{87D83489-039E-4123-BE01-CB62EE932A29} = {78DA8BE5-2D77-49D6-8CA4-7847B65DBE84}
+		{B11B5672-B1E8-4C77-BDA1-4E6620F96BF9} = {87D83489-039E-4123-BE01-CB62EE932A29}
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65} = {87D83489-039E-4123-BE01-CB62EE932A29}
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6} = {87D83489-039E-4123-BE01-CB62EE932A29}
+		{9FDF5E33-D15D-409F-876E-4E77727936B9} = {87D83489-039E-4123-BE01-CB62EE932A29}
 	EndGlobalSection
 EndGlobal
Index: /pjproject/branches/projects/uwp/pjsip-apps/build/libpjproject.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/build/libpjproject.vcxproj	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjsip-apps/build/libpjproject.vcxproj	(revision 5254)
@@ -79,5 +79,5 @@
   <PropertyGroup Label="Globals">
     <ProjectGuid>{23D7679C-764C-4E02-8B29-BB882CEEEFE2}</ProjectGuid>
-    <RootNamespace>libpjproject</RootNamespace>    
+    <RootNamespace>libpjproject</RootNamespace>
     <!-- Specific UWP property -->
     <DefaultLanguage>en-US</DefaultLanguage>
@@ -200,5 +200,6 @@
   <PropertyGroup>
     <PlatformToolset>$(BuildToolset)</PlatformToolset>
-    <CharacterSet Condition="'$(API_Family)'!='WinDesktop'"></CharacterSet>
+    <CharacterSet Condition="'$(API_Family)'!='WinDesktop'">
+    </CharacterSet>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
@@ -323,4 +324,5 @@
       <PrecompiledHeaderOutputFile>
       </PrecompiledHeaderOutputFile>
+      <RuntimeLibrary>MultiThreadedDebugDLL</RuntimeLibrary>
     </ClCompile>
     <ProjectReference>
Index: /pjproject/branches/projects/uwp/pjsip-apps/build/pjsua.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/build/pjsua.vcxproj	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjsip-apps/build/pjsua.vcxproj	(revision 5254)
@@ -79,5 +79,5 @@
   <PropertyGroup Label="Globals">
     <ProjectGuid>{8310649E-A25E-4AF0-91E8-9E3CC659BB89}</ProjectGuid>
-    <RootNamespace>pjsua</RootNamespace>    
+    <RootNamespace>pjsua</RootNamespace>
     <!-- Specific UWP property -->
     <DefaultLanguage>en-US</DefaultLanguage>
@@ -86,5 +86,5 @@
     <WindowsTargetPlatformVersion Condition="'$(API_Family)'=='UWP'">$(PlatformVersion)</WindowsTargetPlatformVersion>
     <WindowsTargetPlatformMinVersion Condition="'$(API_Family)'=='UWP'">$(PlatformVersion)</WindowsTargetPlatformMinVersion>
-    <ApplicationTypeRevision Condition="'$(API_Family)'=='UWP'">$(AppTypeRev)</ApplicationTypeRevision>    
+    <ApplicationTypeRevision Condition="'$(API_Family)'=='UWP'">$(AppTypeRev)</ApplicationTypeRevision>
   </PropertyGroup>
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.Default.props" />
@@ -200,5 +200,6 @@
   <PropertyGroup>
     <PlatformToolset>$(BuildToolset)</PlatformToolset>
-    <CharacterSet Condition="'$(API_Family)'!='WinDesktop'"></CharacterSet>
+    <CharacterSet Condition="'$(API_Family)'!='WinDesktop'">
+    </CharacterSet>
     <ConfigurationType Condition="'$(API_Family)'=='WinDesktop'">Application</ConfigurationType>
     <ConfigurationType Condition="'$(API_Family)'=='UWP' Or '$(API_Family)'=='WinPhone8'">StaticLibrary</ConfigurationType>
@@ -304,7 +305,7 @@
   <ItemDefinitionGroup>
     <ClCompile>
-      <RuntimeLibrary Condition="'$(API_Family)'=='UWP'">MultiThreadedDebugDLL</RuntimeLibrary>      
-    </ClCompile>
-  </ItemDefinitionGroup>    
+      <RuntimeLibrary Condition="'$(API_Family)'=='UWP'">MultiThreadedDebugDLL</RuntimeLibrary>
+    </ClCompile>
+  </ItemDefinitionGroup>
   <ItemDefinitionGroup Condition="'$(Configuration)|$(Platform)'=='Release|Win32'">
     <ClCompile>
@@ -567,4 +568,5 @@
     <ClInclude Include="..\src\pjsua\pjsua_app.h" />
     <ClInclude Include="..\src\pjsua\pjsua_app_common.h" />
+    <ClInclude Include="..\src\pjsua\pjsua_app_config.h" />
   </ItemGroup>
   <ItemGroup>
Index: /pjproject/branches/projects/uwp/pjsip-apps/build/pjsua.vcxproj.filters
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/build/pjsua.vcxproj.filters	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjsip-apps/build/pjsua.vcxproj.filters	(revision 5254)
@@ -45,4 +45,7 @@
       <Filter>Header Files</Filter>
     </ClInclude>
+    <ClInclude Include="..\src\pjsua\pjsua_app_config.h">
+      <Filter>Header Files</Filter>
+    </ClInclude>
   </ItemGroup>
 </Project>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/comp/pjsua_cli_uwp_comp.vcxproj	(revision 5254)
@@ -81,4 +81,5 @@
     <PlatformToolset>v140</PlatformToolset>
   </PropertyGroup>
+  <!-- Import common config -->
   <Import Project="..\..\..\..\..\..\build\vs\pjproject-vs14-common-config.props" />
   <Import Project="$(VCTargetsPath)\Microsoft.Cpp.props" />
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/uwp/pjsua_cli_uwp.csproj
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/uwp/pjsua_cli_uwp.csproj	(revision 5253)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/cli/uwp/pjsua_cli_uwp.csproj	(revision 5254)
@@ -144,4 +144,7 @@
     </ProjectReference>
   </ItemGroup>
+  <ItemGroup>
+    <WCFMetadata Include="Service References\" />
+  </ItemGroup>
   <PropertyGroup Condition=" '$(VisualStudioVersion)' == '' or '$(VisualStudioVersion)' &lt; '14.0' ">
     <VisualStudioVersion>14.0</VisualStudioVersion>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip.sln
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip.sln	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip.sln	(revision 5254)
@@ -0,0 +1,94 @@
+﻿
+Microsoft Visual Studio Solution File, Format Version 12.00
+# Visual Studio 14
+VisualStudioVersion = 14.0.23107.0
+MinimumVisualStudioVersion = 10.0.40219.1
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Voip", "Voip\Voip.csproj", "{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "VoipHost", "VoipHost\VoipHost.vcxproj", "{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "VoipTasks", "VoipTasks\VoipTasks.csproj", "{9FDF5E33-D15D-409F-876E-4E77727936B9}"
+EndProject
+Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "VoipBackEnd", "VoipBackEnd\VoipBackEnd.vcxproj", "{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}"
+EndProject
+Global
+	GlobalSection(SolutionConfigurationPlatforms) = preSolution
+		Debug|Any CPU = Debug|Any CPU
+		Debug|ARM = Debug|ARM
+		Debug|x64 = Debug|x64
+		Debug|x86 = Debug|x86
+		Release|Any CPU = Release|Any CPU
+		Release|ARM = Release|ARM
+		Release|x64 = Release|x64
+		Release|x86 = Release|x86
+	EndGlobalSection
+	GlobalSection(ProjectConfigurationPlatforms) = postSolution
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|Any CPU.ActiveCfg = Debug|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|ARM.ActiveCfg = Debug|ARM
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|ARM.Build.0 = Debug|ARM
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|ARM.Deploy.0 = Debug|ARM
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|x64.ActiveCfg = Debug|x64
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|x64.Build.0 = Debug|x64
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|x64.Deploy.0 = Debug|x64
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|x86.ActiveCfg = Debug|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|x86.Build.0 = Debug|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Debug|x86.Deploy.0 = Debug|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|Any CPU.ActiveCfg = Release|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|ARM.ActiveCfg = Release|ARM
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|ARM.Build.0 = Release|ARM
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|ARM.Deploy.0 = Release|ARM
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|x64.ActiveCfg = Release|x64
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|x64.Build.0 = Release|x64
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|x64.Deploy.0 = Release|x64
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|x86.ActiveCfg = Release|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|x86.Build.0 = Release|x86
+		{DFD0DAC2-D55D-4CC2-AC95-DD36C6539585}.Release|x86.Deploy.0 = Release|x86
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|Any CPU.ActiveCfg = Debug|Win32
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|ARM.ActiveCfg = Debug|ARM
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|ARM.Build.0 = Debug|ARM
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|x64.ActiveCfg = Debug|x64
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|x64.Build.0 = Debug|x64
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|x86.ActiveCfg = Debug|Win32
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Debug|x86.Build.0 = Debug|Win32
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|Any CPU.ActiveCfg = Release|Win32
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|ARM.ActiveCfg = Release|ARM
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|ARM.Build.0 = Release|ARM
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|x64.ActiveCfg = Release|x64
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|x64.Build.0 = Release|x64
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|x86.ActiveCfg = Release|Win32
+		{016D497F-0EE0-449E-89F5-BD63F7F9A8A6}.Release|x86.Build.0 = Release|Win32
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|ARM.ActiveCfg = Debug|ARM
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|ARM.Build.0 = Debug|ARM
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|x64.ActiveCfg = Debug|x64
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|x64.Build.0 = Debug|x64
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|x86.ActiveCfg = Debug|x86
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Debug|x86.Build.0 = Debug|x86
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|Any CPU.Build.0 = Release|Any CPU
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|ARM.ActiveCfg = Release|ARM
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|ARM.Build.0 = Release|ARM
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|x64.ActiveCfg = Release|x64
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|x64.Build.0 = Release|x64
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|x86.ActiveCfg = Release|x86
+		{9FDF5E33-D15D-409F-876E-4E77727936B9}.Release|x86.Build.0 = Release|x86
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|Any CPU.ActiveCfg = Debug|Win32
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|ARM.ActiveCfg = Debug|ARM
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|ARM.Build.0 = Debug|ARM
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|x64.ActiveCfg = Debug|x64
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|x64.Build.0 = Debug|x64
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|x86.ActiveCfg = Debug|Win32
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Debug|x86.Build.0 = Debug|Win32
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|Any CPU.ActiveCfg = Release|Win32
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|ARM.ActiveCfg = Release|ARM
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|ARM.Build.0 = Release|ARM
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|x64.ActiveCfg = Release|x64
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|x64.Build.0 = Release|x64
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|x86.ActiveCfg = Release|Win32
+		{FC9CBB95-624C-4CE8-86A8-3AB5A415AA65}.Release|x86.Build.0 = Release|Win32
+	EndGlobalSection
+	GlobalSection(SolutionProperties) = preSolution
+		HideSolutionNode = FALSE
+	EndGlobalSection
+EndGlobal
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml	(revision 5254)
@@ -0,0 +1,8 @@
+﻿<Application
+    x:Class="VoipUI.App"
+    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
+    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
+    xmlns:local="using:VoipUI"
+    RequestedTheme="Light">
+
+</Application>
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml.cs
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml.cs	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/App.xaml.cs	(revision 5254)
@@ -0,0 +1,139 @@
+﻿using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Linq;
+using System.Runtime.InteropServices.WindowsRuntime;
+using Windows.ApplicationModel;
+using Windows.ApplicationModel.Activation;
+using Windows.Foundation;
+using Windows.Foundation.Collections;
+using Windows.UI.Xaml;
+using Windows.UI.Xaml.Controls;
+using Windows.UI.Xaml.Controls.Primitives;
+using Windows.UI.Xaml.Data;
+using Windows.UI.Xaml.Input;
+using Windows.UI.Xaml.Media;
+using Windows.UI.Xaml.Navigation;
+using VoipTasks.BackgroundOperations;
+using VoipUI.Helpers;
+using System.Diagnostics;
+
+namespace VoipUI
+{
+    /// <summary>
+    /// Provides application-specific behavior to supplement the default Application class.
+    /// </summary>
+    sealed partial class App : Application
+    {
+        /// <summary>
+        /// Initializes the singleton application object.  This is the first line of authored code
+        /// executed, and as such is the logical equivalent of main() or WinMain().
+        /// </summary>
+        public App()
+        {
+            Microsoft.ApplicationInsights.WindowsAppInitializer.InitializeAsync(
+                Microsoft.ApplicationInsights.WindowsCollectors.Metadata |
+                Microsoft.ApplicationInsights.WindowsCollectors.Session);
+            this.InitializeComponent();
+            this.Suspending += OnSuspending;
+        }
+
+        /// <summary>
+        /// Invoked when the application is launched normally by the end user.  Other entry points
+        /// will be used such as when the application is launched to open a specific file.
+        /// </summary>
+        /// <param name="e">Details about the launch request and process.</param>
+        protected override void OnLaunched(LaunchActivatedEventArgs e)
+        {
+
+#if DEBUG
+            if (System.Diagnostics.Debugger.IsAttached)
+            {
+                this.DebugSettings.EnableFrameRateCounter = true;
+            }
+#endif
+
+            Frame rootFrame = Window.Current.Content as Frame;
+
+            // Do not repeat app initialization when the Window already has content,
+            // just ensure that the window is active
+            if (rootFrame == null)
+            {
+                // Create a Frame to act as the navigation context and navigate to the first page
+                rootFrame = new Frame();
+
+                rootFrame.NavigationFailed += OnNavigationFailed;
+
+                if (e.PreviousExecutionState == ApplicationExecutionState.Terminated)
+                {
+                    //TODO: Load state from previously suspended application
+                }
+
+                // Place the frame in the current Window
+                Window.Current.Content = rootFrame;
+            }
+
+            if (rootFrame.Content == null)
+            {
+                // When the navigation stack isn't restored navigate to the first page,
+                // configuring the new page by passing required information as a navigation
+                // parameter
+                rootFrame.Navigate(typeof(MainPage), e.Arguments);
+            }
+
+            /* Start service. */
+            StartServiceAsync();
+
+            // Ensure the current window is active
+            Window.Current.Activate();
+        }
+
+        private async void GetAccountInfoAsync()
+        {
+            try
+            {
+                OperationResult result = await EndpointHelper.GetAccountInfo();
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        private async void StartServiceAsync()
+        {
+            try
+            {
+                OperationResult result = await EndpointHelper.StartServiceAsync();                                    
+            }
+            catch (Exception ex)
+            {
+                Debug.WriteLine(ex.Message);
+            }
+        }
+
+        /// <summary>
+        /// Invoked when Navigation to a certain page fails
+        /// </summary>
+        /// <param name="sender">The Frame which failed navigation</param>
+        /// <param name="e">Details about the navigation failure</param>
+        void OnNavigationFailed(object sender, NavigationFailedEventArgs e)
+        {
+            throw new Exception("Failed to load Page " + e.SourcePageType.FullName);
+        }
+
+        /// <summary>
+        /// Invoked when application execution is being suspended.  Application state is saved
+        /// without knowing whether the application will be terminated or resumed with the contents
+        /// of memory still intact.
+        /// </summary>
+        /// <param name="sender">The source of the suspend request.</param>
+        /// <param name="e">Details about the suspend request.</param>
+        private void OnSuspending(object sender, SuspendingEventArgs e)
+        {
+            var deferral = e.SuspendingOperation.GetDeferral();
+            //TODO: Save application state and stop any background activity
+            deferral.Complete();
+        }
+    }
+}
Index: /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/AppServiceHelper.cs
===================================================================
--- /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/AppServiceHelper.cs	(revision 5254)
+++ /pjproject/branches/projects/uwp/pjsip-apps/src/pjsua/winrt/gui/uwp/Voip/Helpers/AppServiceHelper.cs	(revision 5254)
@@ -0,0 +1,218 @@
+﻿//*********************************************************
+//
+// Copyright (c) Microsoft. All rights reserved.
+// This code is licensed under the MIT License (MIT).
+// THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
+// ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
+// IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
+// PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.
+//
+//*********************************************************
+using System;
+using System.Threading.Tasks;
+using VoipTasks.BackgroundOperations;
+using Windows.ApplicationModel.AppService;
+using Windows.Foundation.Collections;
+using Windows.ApplicationModel.Core;
+using Windows.UI.Core;
+
+namespace VoipUI.Helpers
+{
+    class AppServiceHelper
+    {
+        ~AppServiceHelper()
+        {
+            if (_appConnection != null)
+            {
+                _appConnection.Dispose();
+                _appConnection = null;
+            }
+        }
+
+        public async Task<ValueSet> SendMessageAsync(ValueSet message)
+        {
+            ValueSet returnValue = null;
+            AppServiceConnection appConnection = await GetAppConnectionAsync();
+
+            if (appConnection != null)
+            {
+                AppServiceResponse response = await appConnection.SendMessageAsync(message);
+
+                if (response.Status == AppServiceResponseStatus.Success)
+                {
+                    if (response.Message.Keys.Contains(BackgroundOperation.Result))
+                    {
+                        returnValue = response.Message;
+                    }
+                }
+            }
+
+            return returnValue;
+        }
+
+        public async void SendMessage(ValueSet message)
+        {
+            AppServiceConnection appConnection = await GetAppConnectionAsync();
+
+            if (appConnection != null)
+            {
+                await appConnection.SendMessageAsync(message);
+            }
+        }
+
+        private async Task<AppServiceConnection> GetAppConnectionAsync()
+        {
+            AppServiceConnection appConnection = _appConnection;
+
+            if (appConnection == null)
+            {
+                appConnection = new AppServiceConnection();
+
+                appConnection.ServiceClosed += AppConnection_ServiceClosed;
+
+                appConnection.AppServiceName = BackgroundOperation.AppServiceName;
+
+                appConnection.PackageFamilyName = Windows.ApplicationModel.Package.Current.Id.FamilyName;
+
+                AppServiceConnectionStatus status = await appConnection.OpenAsync();
+
+                if (status == AppServiceConnectionStatus.Success)
+                {
+                    _appConnection = appConnection;
+                    _appConnection.RequestReceived += Connection_RequestReceived;
+                }
+            }
+
+            return appConnection;
+        }
+
+        private void AppConnection_ServiceClosed(AppServiceConnection sender, AppServiceClosedEventArgs args)
+        {
+            _appConnection = null;
+        }
+
+        private async void Connection_RequestReceived(AppServiceConnection sender, AppServiceRequestReceivedEventArgs args)
+        {
+            var deferral = args.GetDeferral();
+            var response = new ValueSet();
+            //bool stop = false;
+            try
+            {
+                var request = args.Request;
+                var message = request.Message;
+                if (message.ContainsKey(ForegroundOperation.NewForegroundRequest))
+                {
+                    switch ((ForegroundReguest)message[ForegroundOperation.NewForegroundRequest])
+                    {
+                        case ForegroundReguest.UpdateCallState:
+                            AppRequest = args.Request;
+                            Request = ForegroundReguest.UpdateCallState;
+                            AppRequestDeferal = deferral;
+
+                            await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () => {
+
+                                MainPage.Current.UpdateCallState(message[UpdateCallStateArguments.CallState.ToString()] as String);
+                            });
+                            
+                            break;
+
+                        case ForegroundReguest.UpdateRegState:
+                            AppRequest = args.Request;
+                            Request = ForegroundReguest.UpdateRegState;
+                            AppRequestDeferal = deferral;
+
+                            await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () => {
+
+                                MainPage.Current.UpdateRegState(message[UpdateRegStateArguments.RegState.ToString()] as String);
+                            });
+
+                            break;
+
+                        case ForegroundReguest.UpdateAcccountInfo:
+                            AppRequest = args.Request;
+                            Request = ForegroundReguest.UpdateAcccountInfo;
+                            AppRequestDeferal = deferral;
+
+                            await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(CoreDispatcherPriority.Normal, () => {
+
+                                MainPage.Current.UpdateAccountInfo(message[UpdateAccountInfoArguments.id.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.registrar.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.proxy.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.username.ToString()] as String,
+                                                                   message[UpdateAccountInfoArguments.password.ToString()] as String);
+                            });
+
+                            break;
+
+                        default:
+                            break;
+                    }
+                }
+            }
+            finally
+            {
+            }
+        }
+
+        public static AppServiceRequest AppRequest
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _appRequest = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _appRequest;
+                }
+            }
+        }
+
+        public static AppServiceDeferral AppRequestDeferal
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _appDeferral = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _appDeferral;
+                }
+            }
+        }
+
+        public static ForegroundReguest Request
+        {
+            set
+            {
+                lock (_lock)
+                {
+                    _request = value;
+                }
+            }
+            get
+            {
+                lock (_lock)
+                {
+                    return _request;
+                }
+            }
+        }
+
+        private AppServiceConnection _appConnection = null;
+
+        private static AppServiceRequest _appRequest = null;
+        private static AppServiceDeferral _appDeferral = null;
+        private static ForegroundReguest _request = ForegroundReguest.InValid;
+        private static Object _lock = new Object();
+    }
+}
